(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('lodash.orderby'), require('rxjs'), require('lodash.min')) :
  typeof define === 'function' && define.amd ? define('@troplabs/angular-datatable', ['exports', '@angular/core', '@angular/common', 'lodash.orderby', 'rxjs', 'lodash.min'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.troplabs = global.troplabs || {}, global.troplabs['angular-datatable'] = {}), global.ng.core, global.ng.common, global.orderBy, global.rxjs, global.min));
}(this, (function (exports, core, common, orderBy, rxjs, min) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var orderBy__default = /*#__PURE__*/_interopDefaultLegacy(orderBy);
  var min__default = /*#__PURE__*/_interopDefaultLegacy(min);

  /******************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  /* global Reflect, Promise, SuppressedError, Symbol, Iterator */
  var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf ||
          ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
          function (d, b) { for (var p in b)
              if (Object.prototype.hasOwnProperty.call(b, p))
                  d[p] = b[p]; };
      return extendStatics(d, b);
  };
  function __extends(d, b) {
      if (typeof b !== "function" && b !== null)
          throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() { this.constructor = d; }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  }
  var __assign = function () {
      __assign = Object.assign || function __assign(t) {
          for (var s, i = 1, n = arguments.length; i < n; i++) {
              s = arguments[i];
              for (var p in s)
                  if (Object.prototype.hasOwnProperty.call(s, p))
                      t[p] = s[p];
          }
          return t;
      };
      return __assign.apply(this, arguments);
  };
  function __rest(s, e) {
      var t = {};
      for (var p in s)
          if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
              t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
          for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
              if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                  t[p[i]] = s[p[i]];
          }
      return t;
  }
  function __decorate(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
          r = Reflect.decorate(decorators, target, key, desc);
      else
          for (var i = decorators.length - 1; i >= 0; i--)
              if (d = decorators[i])
                  r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
  }
  function __param(paramIndex, decorator) {
      return function (target, key) { decorator(target, key, paramIndex); };
  }
  function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
      function accept(f) { if (f !== void 0 && typeof f !== "function")
          throw new TypeError("Function expected"); return f; }
      var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
      var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
      var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
      var _, done = false;
      for (var i = decorators.length - 1; i >= 0; i--) {
          var context = {};
          for (var p in contextIn)
              context[p] = p === "access" ? {} : contextIn[p];
          for (var p in contextIn.access)
              context.access[p] = contextIn.access[p];
          context.addInitializer = function (f) { if (done)
              throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
          var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
          if (kind === "accessor") {
              if (result === void 0)
                  continue;
              if (result === null || typeof result !== "object")
                  throw new TypeError("Object expected");
              if (_ = accept(result.get))
                  descriptor.get = _;
              if (_ = accept(result.set))
                  descriptor.set = _;
              if (_ = accept(result.init))
                  initializers.unshift(_);
          }
          else if (_ = accept(result)) {
              if (kind === "field")
                  initializers.unshift(_);
              else
                  descriptor[key] = _;
          }
      }
      if (target)
          Object.defineProperty(target, contextIn.name, descriptor);
      done = true;
  }
  ;
  function __runInitializers(thisArg, initializers, value) {
      var useValue = arguments.length > 2;
      for (var i = 0; i < initializers.length; i++) {
          value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
      }
      return useValue ? value : void 0;
  }
  ;
  function __propKey(x) {
      return typeof x === "symbol" ? x : "".concat(x);
  }
  ;
  function __setFunctionName(f, name, prefix) {
      if (typeof name === "symbol")
          name = name.description ? "[".concat(name.description, "]") : "";
      return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
  }
  ;
  function __metadata(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
          return Reflect.metadata(metadataKey, metadataValue);
  }
  function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
      return new (P || (P = Promise))(function (resolve, reject) {
          function fulfilled(value) { try {
              step(generator.next(value));
          }
          catch (e) {
              reject(e);
          } }
          function rejected(value) { try {
              step(generator["throw"](value));
          }
          catch (e) {
              reject(e);
          } }
          function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
          step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
  }
  function __generator(thisArg, body) {
      var _ = { label: 0, sent: function () { if (t[0] & 1)
              throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
      return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
      function verb(n) { return function (v) { return step([n, v]); }; }
      function step(op) {
          if (f)
              throw new TypeError("Generator is already executing.");
          while (g && (g = 0, op[0] && (_ = 0)), _)
              try {
                  if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                      return t;
                  if (y = 0, t)
                      op = [op[0] & 2, t.value];
                  switch (op[0]) {
                      case 0:
                      case 1:
                          t = op;
                          break;
                      case 4:
                          _.label++;
                          return { value: op[1], done: false };
                      case 5:
                          _.label++;
                          y = op[1];
                          op = [0];
                          continue;
                      case 7:
                          op = _.ops.pop();
                          _.trys.pop();
                          continue;
                      default:
                          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                              _ = 0;
                              continue;
                          }
                          if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                              _.label = op[1];
                              break;
                          }
                          if (op[0] === 6 && _.label < t[1]) {
                              _.label = t[1];
                              t = op;
                              break;
                          }
                          if (t && _.label < t[2]) {
                              _.label = t[2];
                              _.ops.push(op);
                              break;
                          }
                          if (t[2])
                              _.ops.pop();
                          _.trys.pop();
                          continue;
                  }
                  op = body.call(thisArg, _);
              }
              catch (e) {
                  op = [6, e];
                  y = 0;
              }
              finally {
                  f = t = 0;
              }
          if (op[0] & 5)
              throw op[1];
          return { value: op[0] ? op[1] : void 0, done: true };
      }
  }
  var __createBinding = Object.create ? (function (o, m, k, k2) {
      if (k2 === undefined)
          k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
          desc = { enumerable: true, get: function () { return m[k]; } };
      }
      Object.defineProperty(o, k2, desc);
  }) : (function (o, m, k, k2) {
      if (k2 === undefined)
          k2 = k;
      o[k2] = m[k];
  });
  function __exportStar(m, o) {
      for (var p in m)
          if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
              __createBinding(o, m, p);
  }
  function __values(o) {
      var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
      if (m)
          return m.call(o);
      if (o && typeof o.length === "number")
          return {
              next: function () {
                  if (o && i >= o.length)
                      o = void 0;
                  return { value: o && o[i++], done: !o };
              }
          };
      throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  }
  function __read(o, n) {
      var m = typeof Symbol === "function" && o[Symbol.iterator];
      if (!m)
          return o;
      var i = m.call(o), r, ar = [], e;
      try {
          while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
              ar.push(r.value);
      }
      catch (error) {
          e = { error: error };
      }
      finally {
          try {
              if (r && !r.done && (m = i["return"]))
                  m.call(i);
          }
          finally {
              if (e)
                  throw e.error;
          }
      }
      return ar;
  }
  /** @deprecated */
  function __spread() {
      for (var ar = [], i = 0; i < arguments.length; i++)
          ar = ar.concat(__read(arguments[i]));
      return ar;
  }
  /** @deprecated */
  function __spreadArrays() {
      for (var s = 0, i = 0, il = arguments.length; i < il; i++)
          s += arguments[i].length;
      for (var r = Array(s), k = 0, i = 0; i < il; i++)
          for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
              r[k] = a[j];
      return r;
  }
  function __spreadArray(to, from, pack) {
      if (pack || arguments.length === 2)
          for (var i = 0, l = from.length, ar; i < l; i++) {
              if (ar || !(i in from)) {
                  if (!ar)
                      ar = Array.prototype.slice.call(from, 0, i);
                  ar[i] = from[i];
              }
          }
      return to.concat(ar || Array.prototype.slice.call(from));
  }
  function __await(v) {
      return this instanceof __await ? (this.v = v, this) : new __await(v);
  }
  function __asyncGenerator(thisArg, _arguments, generator) {
      if (!Symbol.asyncIterator)
          throw new TypeError("Symbol.asyncIterator is not defined.");
      var g = generator.apply(thisArg, _arguments || []), i, q = [];
      return i = Object.create((typeof AsyncIterator === "function" ? AsyncIterator : Object).prototype), verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
      function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
      function verb(n, f) { if (g[n]) {
          i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); };
          if (f)
              i[n] = f(i[n]);
      } }
      function resume(n, v) { try {
          step(g[n](v));
      }
      catch (e) {
          settle(q[0][3], e);
      } }
      function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
      function fulfill(value) { resume("next", value); }
      function reject(value) { resume("throw", value); }
      function settle(f, v) { if (f(v), q.shift(), q.length)
          resume(q[0][0], q[0][1]); }
  }
  function __asyncDelegator(o) {
      var i, p;
      return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
      function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
  }
  function __asyncValues(o) {
      if (!Symbol.asyncIterator)
          throw new TypeError("Symbol.asyncIterator is not defined.");
      var m = o[Symbol.asyncIterator], i;
      return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
      function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
      function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
  }
  function __makeTemplateObject(cooked, raw) {
      if (Object.defineProperty) {
          Object.defineProperty(cooked, "raw", { value: raw });
      }
      else {
          cooked.raw = raw;
      }
      return cooked;
  }
  ;
  var __setModuleDefault = Object.create ? (function (o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
  }) : function (o, v) {
      o["default"] = v;
  };
  function __importStar(mod) {
      if (mod && mod.__esModule)
          return mod;
      var result = {};
      if (mod != null)
          for (var k in mod)
              if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                  __createBinding(result, mod, k);
      __setModuleDefault(result, mod);
      return result;
  }
  function __importDefault(mod) {
      return (mod && mod.__esModule) ? mod : { default: mod };
  }
  function __classPrivateFieldGet(receiver, state, kind, f) {
      if (kind === "a" && !f)
          throw new TypeError("Private accessor was defined without a getter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
          throw new TypeError("Cannot read private member from an object whose class did not declare it");
      return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
  }
  function __classPrivateFieldSet(receiver, state, value, kind, f) {
      if (kind === "m")
          throw new TypeError("Private method is not writable");
      if (kind === "a" && !f)
          throw new TypeError("Private accessor was defined without a setter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
          throw new TypeError("Cannot write private member to an object whose class did not declare it");
      return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
  }
  function __classPrivateFieldIn(state, receiver) {
      if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
          throw new TypeError("Cannot use 'in' operator on non-object");
      return typeof state === "function" ? receiver === state : state.has(receiver);
  }
  function __addDisposableResource(env, value, async) {
      if (value !== null && value !== void 0) {
          if (typeof value !== "object" && typeof value !== "function")
              throw new TypeError("Object expected.");
          var dispose, inner;
          if (async) {
              if (!Symbol.asyncDispose)
                  throw new TypeError("Symbol.asyncDispose is not defined.");
              dispose = value[Symbol.asyncDispose];
          }
          if (dispose === void 0) {
              if (!Symbol.dispose)
                  throw new TypeError("Symbol.dispose is not defined.");
              dispose = value[Symbol.dispose];
              if (async)
                  inner = dispose;
          }
          if (typeof dispose !== "function")
              throw new TypeError("Object not disposable.");
          if (inner)
              dispose = function () { try {
                  inner.call(this);
              }
              catch (e) {
                  return Promise.reject(e);
              } };
          env.stack.push({ value: value, dispose: dispose, async: async });
      }
      else if (async) {
          env.stack.push({ async: true });
      }
      return value;
  }
  var _SuppressedError = typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
      var e = new Error(message);
      return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
  };
  function __disposeResources(env) {
      function fail(e) {
          env.error = env.hasError ? new _SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
          env.hasError = true;
      }
      var r, s = 0;
      function next() {
          while (r = env.stack.pop()) {
              try {
                  if (!r.async && s === 1)
                      return s = 0, env.stack.push(r), Promise.resolve().then(next);
                  if (r.dispose) {
                      var result = r.dispose.call(r.value);
                      if (r.async)
                          return s |= 2, Promise.resolve(result).then(next, function (e) { fail(e); return next(); });
                  }
                  else
                      s |= 1;
              }
              catch (e) {
                  fail(e);
              }
          }
          if (s === 1)
              return env.hasError ? Promise.reject(env.error) : Promise.resolve();
          if (env.hasError)
              throw env.error;
      }
      return next();
  }
  var tslib_es6 = {
      __extends: __extends,
      __assign: __assign,
      __rest: __rest,
      __decorate: __decorate,
      __param: __param,
      __metadata: __metadata,
      __awaiter: __awaiter,
      __generator: __generator,
      __createBinding: __createBinding,
      __exportStar: __exportStar,
      __values: __values,
      __read: __read,
      __spread: __spread,
      __spreadArrays: __spreadArrays,
      __spreadArray: __spreadArray,
      __await: __await,
      __asyncGenerator: __asyncGenerator,
      __asyncDelegator: __asyncDelegator,
      __asyncValues: __asyncValues,
      __makeTemplateObject: __makeTemplateObject,
      __importStar: __importStar,
      __importDefault: __importDefault,
      __classPrivateFieldGet: __classPrivateFieldGet,
      __classPrivateFieldSet: __classPrivateFieldSet,
      __classPrivateFieldIn: __classPrivateFieldIn,
      __addDisposableResource: __addDisposableResource,
      __disposeResources: __disposeResources,
  };

  var AngularDatatableDirective = /** @class */ (function () {
      function AngularDatatableDirective(differs) {
          this.differs = differs;
          this.inputData = [];
          this.sortBy = "";
          this.sortOrder = "asc";
          this.sortByChange = new core.EventEmitter();
          this.sortOrderChange = new core.EventEmitter();
          this.rowsOnPage = 1000;
          this.activePage = 1;
          this.mustRecalculateData = false;
          this.onSortChange = new rxjs.ReplaySubject(1);
          this.onPageChange = new core.EventEmitter();
          this.diff = differs.find([]).create(null);
      }
      AngularDatatableDirective.prototype.getSort = function () {
          return { sortBy: this.sortBy, sortOrder: this.sortOrder };
      };
      AngularDatatableDirective.prototype.setSort = function (sortBy, sortOrder) {
          if (this.sortBy !== sortBy || this.sortOrder !== sortOrder) {
              this.sortBy = sortBy;
              this.sortOrder = (["asc", "desc"].includes(sortOrder) ? sortOrder : "asc");
              this.mustRecalculateData = true;
              this.onSortChange.next({ sortBy: sortBy, sortOrder: sortOrder });
              this.sortByChange.emit(this.sortBy);
              this.sortOrderChange.emit(this.sortOrder);
          }
      };
      AngularDatatableDirective.prototype.getPage = function () {
          return { activePage: this.activePage, rowsOnPage: this.rowsOnPage, dataLength: this.inputData.length };
      };
      AngularDatatableDirective.prototype.setPage = function (activePage, rowsOnPage) {
          if (this.rowsOnPage !== rowsOnPage || this.activePage !== activePage) {
              this.activePage = this.activePage !== activePage ? activePage : this.calculateNewActivePage(this.rowsOnPage, rowsOnPage);
              this.rowsOnPage = rowsOnPage;
              this.mustRecalculateData = true;
              this.onPageChange.emit({
                  activePage: this.activePage,
                  rowsOnPage: this.rowsOnPage,
                  dataLength: this.inputData ? this.inputData.length : 0
              });
          }
      };
      AngularDatatableDirective.prototype.calculateNewActivePage = function (previousRowsOnPage, currentRowsOnPage) {
          var firstRowOnPage = (this.activePage - 1) * previousRowsOnPage + 1;
          var newActivePage = Math.ceil(firstRowOnPage / currentRowsOnPage);
          return newActivePage;
      };
      AngularDatatableDirective.prototype.recalculatePage = function () {
          var lastPage = Math.ceil(this.inputData.length / this.rowsOnPage);
          this.activePage = lastPage < this.activePage ? lastPage : this.activePage;
          this.activePage = this.activePage || 1;
          this.onPageChange.emit({
              activePage: this.activePage,
              rowsOnPage: this.rowsOnPage,
              dataLength: this.inputData.length
          });
      };
      AngularDatatableDirective.prototype.ngOnChanges = function (changes) {
          if (changes["rowsOnPage"]) {
              this.rowsOnPage = changes["rowsOnPage"].previousValue;
              this.setPage(this.activePage, changes["rowsOnPage"].currentValue);
              this.mustRecalculateData = true;
          }
          if (changes["sortBy"] || changes["sortOrder"]) {
              if (!["asc", "desc"].includes(this.sortOrder)) {
                  console.warn("angular2-datatable: value for input mfSortOrder must be one of ['asc', 'desc'], but is:", this.sortOrder);
                  this.sortOrder = "asc";
              }
              if (this.sortBy) {
                  this.onSortChange.next({ sortBy: this.sortBy, sortOrder: this.sortOrder });
              }
              this.mustRecalculateData = true;
          }
          if (changes["inputData"]) {
              this.inputData = changes["inputData"].currentValue || [];
              this.recalculatePage();
              this.mustRecalculateData = true;
          }
      };
      AngularDatatableDirective.prototype.ngDoCheck = function () {
          var changes = this.diff.diff(this.inputData);
          if (changes) {
              this.recalculatePage();
              this.mustRecalculateData = true;
          }
          if (this.mustRecalculateData) {
              this.fillData();
              this.mustRecalculateData = false;
          }
      };
      AngularDatatableDirective.prototype.fillData = function () {
          this.activePage = this.activePage;
          this.rowsOnPage = this.rowsOnPage;
          var offset = (this.activePage - 1) * this.rowsOnPage;
          var data = this.inputData;
          var sortBy = this.sortBy;
          if (typeof sortBy === 'string' || sortBy instanceof String) {
              data = orderBy__default['default'](data, this.caseInsensitiveIteratee(sortBy), [this.sortOrder]);
          }
          else {
              data = orderBy__default['default'](data, sortBy, [this.sortOrder]);
          }
          data = data.slice(offset, offset + this.rowsOnPage);
          this.data = data;
      };
      AngularDatatableDirective.prototype.caseInsensitiveIteratee = function (sortBy) {
          return function (row) {
              var e_1, _a;
              var value = row;
              try {
                  for (var _b = __values(sortBy.split('.')), _c = _b.next(); !_c.done; _c = _b.next()) {
                      var sortByProperty = _c.value;
                      if (value) {
                          value = value[sortByProperty];
                      }
                  }
              }
              catch (e_1_1) { e_1 = { error: e_1_1 }; }
              finally {
                  try {
                      if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                  }
                  finally { if (e_1) throw e_1.error; }
              }
              if (value && typeof value === 'string' || value instanceof String) {
                  return value.toLowerCase();
              }
              return value;
          };
      };
      return AngularDatatableDirective;
  }());
  AngularDatatableDirective.decorators = [
      { type: core.Directive, args: [{
                  selector: 'table[mfData]',
                  exportAs: 'mfDataTable'
              },] }
  ];
  AngularDatatableDirective.ctorParameters = function () { return [
      { type: core.IterableDiffers }
  ]; };
  AngularDatatableDirective.propDecorators = {
      inputData: [{ type: core.Input, args: ["mfData",] }],
      sortBy: [{ type: core.Input, args: ["mfSortBy",] }],
      sortOrder: [{ type: core.Input, args: ["mfSortOrder",] }],
      sortByChange: [{ type: core.Output, args: ["mfSortByChange",] }],
      sortOrderChange: [{ type: core.Output, args: ["mfSortOrderChange",] }],
      rowsOnPage: [{ type: core.Input, args: ["mfRowsOnPage",] }],
      activePage: [{ type: core.Input, args: ["mfActivePage",] }]
  };

  var DefaultSorterComponent = /** @class */ (function () {
      function DefaultSorterComponent(mfTable) {
          this.mfTable = mfTable;
          this.isSortedByMeAsc = false;
          this.isSortedByMeDesc = false;
      }
      DefaultSorterComponent.prototype.ngOnInit = function () {
          var _this = this;
          this.mfTable.onSortChange.subscribe(function (event) {
              _this.isSortedByMeAsc = (event.sortBy == _this.sortBy && event.sortOrder == "asc");
              _this.isSortedByMeDesc = (event.sortBy == _this.sortBy && event.sortOrder == "desc");
          });
      };
      DefaultSorterComponent.prototype.sort = function () {
          if (this.isSortedByMeAsc) {
              this.mfTable.setSort(this.sortBy, "desc");
          }
          else {
              this.mfTable.setSort(this.sortBy, "asc");
          }
      };
      return DefaultSorterComponent;
  }());
  DefaultSorterComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'mf-default-sorter',
                  template: "\n  <a style=\"cursor: pointer\" (click)=\"sort()\" class=\"text-nowrap\">\n      <ng-content></ng-content>\n      <span *ngIf=\"isSortedByMeAsc\" class=\"glyphicon glyphicon-triangle-top fa fa-sort-up\" aria-hidden=\"true\"></span>\n      <span *ngIf=\"isSortedByMeDesc\" class=\"glyphicon glyphicon-triangle-bottom fa fa-sort-down\" aria-hidden=\"true\"></span>\n  </a>"
              },] }
  ];
  DefaultSorterComponent.ctorParameters = function () { return [
      { type: AngularDatatableDirective }
  ]; };
  DefaultSorterComponent.propDecorators = {
      sortBy: [{ type: core.Input, args: ["by",] }]
  };

  var PaginatorComponent = /** @class */ (function () {
      function PaginatorComponent(injectMfTable) {
          var _this = this;
          this.injectMfTable = injectMfTable;
          this.dataLength = 0;
          this.onPageChangeSubscriber = function (event) {
              _this.activePage = event.activePage;
              _this.rowsOnPage = event.rowsOnPage;
              _this.dataLength = event.dataLength;
              _this.lastPage = Math.ceil(_this.dataLength / _this.rowsOnPage);
          };
      }
      PaginatorComponent.prototype.ngOnChanges = function (changes) {
          this.mfTable = this.inputMfTable || this.injectMfTable;
          this.onPageChangeSubscriber(this.mfTable.getPage());
          this.mfTable.onPageChange.subscribe(this.onPageChangeSubscriber);
      };
      PaginatorComponent.prototype.setPage = function (pageNumber) {
          this.mfTable.setPage(pageNumber, this.rowsOnPage);
      };
      PaginatorComponent.prototype.setRowsOnPage = function (rowsOnPage) {
          this.mfTable.setPage(this.activePage, rowsOnPage);
      };
      return PaginatorComponent;
  }());
  PaginatorComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'mf-paginator',
                  template: "<ng-content></ng-content>"
              },] }
  ];
  PaginatorComponent.ctorParameters = function () { return [
      { type: AngularDatatableDirective, decorators: [{ type: core.Optional }] }
  ]; };
  PaginatorComponent.propDecorators = {
      inputMfTable: [{ type: core.Input, args: ["mfTable",] }]
  };

  var BootstrapPaginatorComponent = /** @class */ (function () {
      function BootstrapPaginatorComponent() {
          this.rowsOnPageSet = [];
          this.minRowsOnPage = 0;
      }
      BootstrapPaginatorComponent.prototype.ngOnChanges = function (changes) {
          if (changes.rowsOnPageSet) {
              this.minRowsOnPage = min__default['default'](this.rowsOnPageSet);
          }
      };
      return BootstrapPaginatorComponent;
  }());
  BootstrapPaginatorComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'mf-bootstrap-paginator',
                  template: "\n    <mf-paginator #p [mfTable]=\"mfTable\">\n        <ul class=\"pagination\" *ngIf=\"p.dataLength > p.rowsOnPage\">\n            <li class=\"page-item\" [class.disabled]=\"p.activePage <= 1\" (click)=\"p.setPage(1)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">&laquo;</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage > 4 && p.activePage + 1 > p.lastPage\" (click)=\"p.setPage(p.activePage - 4)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage-4}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage > 3 && p.activePage + 2 > p.lastPage\" (click)=\"p.setPage(p.activePage - 3)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage-3}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage > 2\" (click)=\"p.setPage(p.activePage - 2)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage-2}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage > 1\" (click)=\"p.setPage(p.activePage - 1)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage-1}}</a>\n            </li>\n            <li class=\"page-item active\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage + 1 <= p.lastPage\" (click)=\"p.setPage(p.activePage + 1)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage+1}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage + 2 <= p.lastPage\" (click)=\"p.setPage(p.activePage + 2)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage+2}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage + 3 <= p.lastPage && p.activePage < 3\" (click)=\"p.setPage(p.activePage + 3)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage+3}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage + 4 <= p.lastPage && p.activePage < 2\" (click)=\"p.setPage(p.activePage + 4)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage+4}}</a>\n            </li>\n            <li class=\"page-item\" [class.disabled]=\"p.activePage >= p.lastPage\" (click)=\"p.setPage(p.lastPage)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">&raquo;</a>\n            </li>\n        </ul>\n        <ul class=\"pagination pull-right float-sm-right\" *ngIf=\"p.dataLength > minRowsOnPage\">\n            <li class=\"page-item\" *ngFor=\"let rows of rowsOnPageSet\" [class.active]=\"p.rowsOnPage===rows\" (click)=\"p.setRowsOnPage(rows)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{rows}}</a>\n            </li>\n        </ul>\n    </mf-paginator>\n    "
              },] }
  ];
  BootstrapPaginatorComponent.propDecorators = {
      rowsOnPageSet: [{ type: core.Input, args: ["rowsOnPageSet",] }],
      mfTable: [{ type: core.Input, args: ["mfTable",] }]
  };

  var AngularDatatableModule = /** @class */ (function () {
      function AngularDatatableModule() {
      }
      return AngularDatatableModule;
  }());
  AngularDatatableModule.decorators = [
      { type: core.NgModule, args: [{
                  imports: [
                      common.CommonModule,
                  ],
                  declarations: [AngularDatatableDirective, DefaultSorterComponent, PaginatorComponent, BootstrapPaginatorComponent],
                  exports: [AngularDatatableDirective, DefaultSorterComponent, PaginatorComponent, BootstrapPaginatorComponent]
              },] }
  ];

  /*
   * Public API Surface of angular-datatable
   */

  /**
   * Generated bundle index. Do not edit.
   */

  exports.AngularDatatableDirective = AngularDatatableDirective;
  exports.AngularDatatableModule = AngularDatatableModule;
  exports.BootstrapPaginatorComponent = BootstrapPaginatorComponent;
  exports.DefaultSorterComponent = DefaultSorterComponent;
  exports.PaginatorComponent = PaginatorComponent;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=troplabs-angular-datatable.umd.js.map
